## openstructure 2.3.1

=== CMakeLists.txt ===
#-------------------------------------------------------------------------------
# Author: Marco Biasini
#-------------------------------------------------------------------------------

cmake_minimum_required(VERSION 3.12.1 FATAL_ERROR)

# Set CMake policies
# Behaviour of target_link_libraries, always link by full path. CMP0060 can
# disable this to stay compatible with old projects. We want the new behaviour
# since before we needed to provide the full path ourselves, that is: we
# manually forced CMake to the new scheme.
cmake_policy(SET CMP0060 NEW)

project(OpenStructure CXX C)
set (CMAKE_EXPORT_COMPILE_COMMANDS 1)
set (OST_VERSION_MAJOR 2)
set (OST_VERSION_MINOR 3)
set (OST_VERSION_PATCH 1)
set (OST_VERSION_STRING ${OST_VERSION_MAJOR}.${OST_VERSION_MINOR}.${OST_VERSION_PATCH} )
set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${PROJECT_SOURCE_DIR}/cmake_support)
include(OST)

option(USE_SHADER "whether to compile with shader support"
       OFF)
option(USE_RPATH "embed rpath upon make install"
       OFF)
option(COMPILE_TMTOOLS "whether to compile the tmalign and tmscore programs"
       OFF)
option(PROFILE "whether to compile with profiling support"
       OFF)       
option(ENABLE_GUI "whether the graphical user interface should be enabled"
       ON)
option(ENABLE_GFX "whether graphics support should be enabled"
       ON)
option(OPENGLPREFERENCE_LEGACY "whether to use the OpenGL Legacy GL implementation"
       OFF)
option(ENABLE_INFO "whether openstructure should be compiled with support for the info library"
       ON)
option(USE_NUMPY "whether numpy support is added"
      OFF)
option(USE_DOUBLE_PRECISION "whether to compile in double precision" 
       OFF)
option(ENABLE_SPNAV "whether 3DConnexion devices should be supported"
      OFF)
option(STATIC_PROPERTY_WORKAROUND "workaround for static property bug with some boost/boost_python combinations" OFF)
option(COMPILE_TESTS "whether unit tests should be compiled by default" OFF)
option(ENABLE_STATIC "whether static libraries should be compiled" OFF)
option(UBUNTU_LAYOUT "whether Debian/Ubuntu's lib and libexec directory layout should be used" OFF)
option(HIDDEN_VISIBILITY "on gcc, use -fvisibility=hidden" OFF)
option(ENABLE_MM "whether openmm support is added" OFF)

if (CXX)
  set(CMAKE_CXX_COMPILER ${CXX})
endif()

if (CC)
  set(CMAKE_C_COMPILER ${CC})
endif()

if (FORTRAN_COMPILER)
  set(CMAKE_FORTRAN_COMPILER ${FORTRAN_COMPILER})
endif()



if (PREFIX)
  set(CMAKE_INSTALL_PREFIX ${PREFIX})
endif()

if (SYS_ROOT)
  set(CMAKE_PREFIX_PATH ${SYS_ROOT})
endif()

if (OPTIMIZE)
  set(CMAKE_BUILD_TYPE Release)
  set(_OPT ON)
else()
   set(CMAKE_BUILD_TYPE Debug)
    set(_OPT OFF)
endif()

if (USE_DOUBLE_PRECISION)
  set(_DOUBLE_PREC ON)
else()
  set(_DOUBLE_PREC OFF)
  set(_DOUBLE_PREC OFF)
endif()

if (NOT ENABLE_INFO)
  set(ENABLE_GFX OFF)
endif()

if (NOT ENABLE_GFX)
  set(ENABLE_GUI OFF)
endif()

if (ENABLE_INFO)
  set(_INFO ON)
else()
  set(_INFO OFF)
endif()

if (ENABLE_GUI)
  set(_UI ON)
else()
  set(_UI OFF)
endif()

if (ENABLE_GFX)
  set(_OPENGL ON)
else()
  set(_OPENGL OFF)
endif()

if (USE_SHADER)
  set(_SHADER ON)
else()
  set(_SHADER OFF)
endif()
if (USE_NUMPY)
  set(_NUMPY ON)
else()
  set(_NUMPY OFF)
endif()
if (COMPILE_TMTOOLS)
  set(_TM_TOOLS ON)
else()
  set(_TM_TOOLS OFF)
endif()
if (PROFILE)
  set(_PROFILE ON)
else()
  set(_PROFILE OFF)
endif()
if(ENABLE_MM)
  set(_OPENMM ON)
else()
  set(_OPENMM OFF)
endif()


if (UBUNTU_LAYOUT)
  set(_UBUNTU_LAYOUT ON)
else()
  set(_UBUNTU_LAYOUT OFF)
endif()

if (COMPOUND_LIB)
  set(_COMP_LIB "${COMPOUND_LIB}")
  if (NOT IS_ABSOLUTE "${COMPOUND_LIB}")
    set(COMPOUND_LIB "${CMAKE_CURRENT_BINARY_DIR}/${COMPOUND_LIB}")
  endif()
else()
  set(_COMP_LIB "NONE")
endif()

if (STATIC_PROPERTY_WORKAROUND)
  set(_STATICPROPS ON)
else()
  set(_STATICPROPS OFF)
endif()

if (NOT CMAKE_BUILD_TYPE)
  set(CMAKE_BUILD_TYPE Debug)
endif()

setup_stage()
file(MAKE_DIRECTORY ${STAGE_DIR}
     ${EXECUTABLE_OUTPUT_PATH}
     ${HEADER_STAGE_PATH}
     ${LIB_STAGE_PATH}
     ${LIBEXEC_STAGE_PATH})

setup_compiler_flags()

set(CMAKE_LIBRARY_OUTPUT_DIRECTORY)

if (ENABLE_STATIC AND UNIX AND NOT APPLE)
  set (CMAKE_FIND_LIBRARY_SUFFIXES .a)
endif()

# Python needed before Boost
find_package(Python 3.6 REQUIRED COMPONENTS Interpreter Development)
# where Python modules live
set(PYTHON_MODULE_PATH "python${Python_VERSION_MAJOR}.${Python_VERSION_MINOR}/site-packages/")

if(BOOST_VERSION)
  message(STATUS "forcing boost to version ${BOOST_VERSION}")
  set(_BOOST_MIN_VERSION ${BOOST_VERSION})
endif()
setup_boost()
if (WIN32)
   ADD_DEFINITIONS("-DBOOST_ALL_NO_LIB")
endif()

if (ENABLE_INFO)        
  find_package(Qt5Xml REQUIRED)
  set(QT_LIBRARIES ${QT_LIBRARIES} Qt5::Xml)
endif()

if (OPTIMIZE)
  if (CXX_FLAGS)
    set (CMAKE_CXX_FLAGS_RELEASE ${CXX_FLAGS})
  endif()
  if (C_FLAGS)
    set (CMAKE_C_FLAGS_RELEASE ${C_FLAGS})
  endif()
else()
  if (CXX_FLAGS)
    set(CMAKE_CXX_FLAGS_DEBUG ${CXX_FLAGS})
  endif()
  if (C_FLAGS)
    set(CMAKE_C_FLAGS_DEBUG ${C_FLAGS})
  endif()
endif()
if (ENABLE_GFX)
  if (OPENGLPREFERENCE_LEGACY)
    set(OpenGL_GL_PREFERENCE LEGACY)
  else()
    set(OpenGL_GL_PREFERENCE GLVND)
  endif(OPENGLPREFERENCE_LEGACY)
  find_package(OpenGL REQUIRED)
endif()

find_package(EIGEN 3.2.0 REQUIRED)
find_package(SQLITE3 3.7.13 REQUIRED)
find_package(PNG REQUIRED)
find_package(FFTW REQUIRED)
find_package(TIFF REQUIRED)

if(USE_NUMPY)
  find_package(Numpy REQUIRED)
endif()

if(ENABLE_MM)
  find_package(OpenMM REQUIRED)
  set(_OPENMM_PLUGINS "${OPEN_MM_PLUGIN_DIR}")
else(ENABLE_MM)
  set(_OPENMM_PLUGINS "NONE")
endif(ENABLE_MM)

if (ENABLE_STATIC)
  set(Boost_LIBRARIES)
  set(Boost_USE_STATIC_LIBS ON)
  find_package(Boost ${_BOOST_MIN_VERSION} 
               COMPONENTS filesystem system iostreams regex thread REQUIRED)
  find_package(ZLIB REQUIRED)
   
  if (UNIX AND NOT APPLE)
    set(STATIC_LIBRARIES ${Boost_LIBRARIES} ${FFTW_LIBRARIES} ${TIFF_LIBRARIES} 
        ${PNG_LIBRARY} ${ZLIB_LIBRARY})
  else ()
    set(STATIC_LIBRARIES ${Boost_LIBRARIES} ${FFTW_LIBRARIES} ${TIFF_LIBRARIES} 
        ${PNG_LIBRARY} ${ZLIB_LIBRARY})
  endif()
endif()

if (ENABLE_GUI)
  find_package(Qt5Widgets REQUIRED)
  find_package(Qt5OpenGL REQUIRED)
  set(QT_LIBRARIES ${QT_LIBRARIES} Qt5::Gui Qt5::Widgets Qt5::Core)
  ost_find_python_module(PyQt5)
  ost_find_python_module_alt("PyQt5.sip;sip")
endif()

if (ENABLE_SPNAV)
  #find_package(SpNav REQUIRED)
  set(_SPNAV ON)
else()
  set(_SPNAV OFF)
endif()

if (CMAKE_COMPILER_IS_GNUCXX)
  # do not write back into cache, otherwise the compile command line gets expanded
  # with multiple -fno-strict-aliasing flags, triggering a complete rebuild whenever
  # cmake is run
  set (CMAKE_CXX_FLAGS_RELEASE "${CMAKE_CXX_FLAGS_RELEASE} -fno-strict-aliasing")
  if("${CMAKE_CXX_COMPILER_VERSION}" VERSION_GREATER "4.6")
    set (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wno-attributes")
  endif("${CMAKE_CXX_COMPILER_VERSION}" VERSION_GREATER "4.6")
  if(HIDDEN_VISIBILITY) 
    set (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fvisibility=hidden")
    set (_HIDDEN_VIS ON)
  else(HIDDEN_VISIBILITY)
    set (_HIDDEN_VIS OFF)
  endif(HIDDEN_VISIBILITY)
endif()

if(CMAKE_CXX_COMPILER_ID MATCHES "Clang")
  set (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wno-unknown-warning-option")
endif(CMAKE_CXX_COMPILER_ID MATCHES "Clang")
if(CMAKE_C_COMPILER_ID MATCHES "Clang")
  set (CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wno-unknown-warning-option")
endif(CMAKE_C_COMPILER_ID MATCHES "Clang")

# basic environment
include_directories(${Boost_INCLUDE_DIRS} 
                    ${FFTW_INCLUDE_DIRS} 
                    ${EIGEN3_INCLUDE_DIRS}
                    ${TIFF_INCLUDE_DIR}
                    ${PNG_INCLUDE_DIRS}
                    ${OPEN_MM_INCLUDE_DIRS}
                    ${SQLITE3_INCLUDE_DIRS}
                    )
if(USE_NUMPY)
include_directories(${PYTHON_NUMPY_INCLUDE_DIR})
endif()

if (UNIX)
  SET(CMAKE_SKIP_BUILD_RPATH  FALSE)
  SET(CMAKE_BUILD_WITH_INSTALL_RPATH FALSE)
  if(USE_RPATH)
    set(_USE_RPATH ON)
    SET(CMAKE_INSTALL_RPATH "$ORIGIN/../${LIB_DIR}")
    SET(CMAKE_INSTALL_RPATH_USE_LINK_PATH TRUE)
  else()
    set(_USE_RPATH OFF)
   SET(CMAKE_INSTALL_RPATH "")
   SET(CMAKE_INSTALL_RPATH_USE_LINK_PATH FALSE)
  endif() 
endif()

if (ENABLE_STATIC)
  SET(CMAKE_SKIP_BUILD_RPATH TRUE)
  SET(LINK_SEARCH_END_STATIC TRUE) 
endif()

add_subdirectory(modules)
add_subdirectory(scripts)
add_subdirectory(tools)
add_subdirectory(actions)
# deployment has to come last, to ensure that all install commands are run before deployment
# magic is done
add_subdirectory(deployment)

set(FILES_TO_BE_REMOVED ${PROJECT_BINARY_DIR}/stage tests)
set_directory_properties(PROPERTIES ADDITIONAL_MAKE_CLEAN_FILES
                             "${FILES_TO_BE_REMOVED}")


#ost_match_boost_python_version(${Python_LIBRARIES})

if (CMAKE_COMPILER_IS_GNUCXX)
   set(HIDDEN_VIS_MSG 
       "\n   Hidden object visibility  (-DHIDDEN_VISIBILITY) : ${_HIDDEN_VIS}")
endif()
message(STATUS 
        "OpenStructure will be built with the following options:\n"
        "   Install Prefix                        (-DPREFIX) : ${CMAKE_INSTALL_PREFIX}\n"
        "   RPath in install                   (-DUSE_RPATH) : ${_USE_RPATH}\n"
        "   Info support                     (-DENABLE_INFO) : ${_INFO}\n"
        "   Graphical interface               (-DENABLE_GUI) : ${_UI}\n"
        "   OpenGL support                    (-DENABLE_GFX) : ${_OPENGL}\n"
        "   Shader support                    (-DUSE_SHADER) : ${_SHADER}\n"
        "   Numpy support                      (-DUSE_NUMPY) : ${_NUMPY}\n"
        "   SpaceNav Device support         (-DENABLE_SPNAV) : ${_SPNAV}\n"
        "   OpenMM support                     (-DENABLE_MM) : ${_OPENMM}\n"
        "   OpenMM plugins            (-DOPEN_MM_PLUGIN_DIR) : ${_OPENMM_PLUGINS}\n"
        "   Optimize                            (-DOPTIMIZE) : ${_OPT}\n"
        "   Profiling support                    (-DPROFILE) : ${_PROFILE}\n"
        "   Double Precision        (-DUSE_DOUBLE_PRECISION) : ${_DOUBLE_PREC}\n"
        "   Compound Lib                    (-DCOMPOUND_LIB) : ${_COMP_LIB}\n"
        "   TMAlign and TMScore          (-DCOMPILE_TMTOOLS) : ${_TM_TOOLS}\n"
        "   Static Libraries               (-DENABLE_STATIC) : ${ENABLE_STATIC}\n"
        "   Debian/Ubuntu directory layout (-DUBUNTU_LAYOUT) : ${_UBUNTU_LAYOUT}"
        ${HIDDEN_VIS_MSG})


# LocalWords:  CMake CMP

=== actions/CMakeLists.txt ===
add_custom_target(actions ALL)

ost_action_init()
ost_action(ost-compare-structures actions)

=== modules/config/CMakeLists.txt ===
set(SUBST_DICT OST_VERSION_MAJOR=${OST_VERSION_MAJOR} OST_VERSION_MINOR=${OST_VERSION_MINOR} 
    OST_VERSION_PATCH=${OST_VERSION_PATCH})

set(OST_CONFIG_HEADERS
base.hh
config.hh
dllexport.hh
version.hh
)

set(animations_enabled 0)

if (USE_SHADER)
  set(shader_support 1)
else()
  set(shader_support 0)
endif()

if (USE_NUMPY)
  set(numpy_support 1)
else()
  set(numpy_support 0)
endif()
if (PROFILE)
  set(profiling_enabled 1)
else()
  set(profiling_enabled 0)
endif()
if (_DOUBLE_PREC)
  set(double_prec 1)
else()
  set(double_prec 0)
endif()
if (_DOUBLE_PREC)
  set(double_prec 1)
else()
  set(double_prec 0)
endif()
if (_STATICPROPS)
  set(static_props 1)
else()
  set(static_props 0)
endif()
if (FFTW_USE_THREADS)
  set(fftw_use_threads 1)
else()
  set(fftw_use_threads 0)
endif()
if (_UBUNTU_LAYOUT)
  set(ubuntu_layout 1)
else()
  set(ubuntu_layout 0)
endif()
if (ENABLE_INFO)
  set(info_enabled 1)
else()
  set(info_enabled 0)
endif()

set(config_hh_generator "CMake")
set(CONFIG_HH_FILE "${CMAKE_CURRENT_SOURCE_DIR}/config.hh")
set(VERSION_HH_FILE "${CMAKE_CURRENT_SOURCE_DIR}/version.hh")
configure_file(config.hh.in ${CONFIG_HH_FILE})
configure_file(version.hh.in ${VERSION_HH_FILE})
add_custom_target(ost_config)
stage_and_install_headers("${OST_CONFIG_HEADERS}" "ost" "ost_config")

=== modules/bindings/pymod/CMakeLists.txt ===
set(OST_BINDINGS
__init__.py
lga.py
hbplus.py
msms.py
tmtools.py 
dssp.py
clustalw.py
utils.py
naccess.py
hhblits.py
hhblits2.py
hhblits3.py
blast.py
cadscore.py
kclust.py
ialign.py
mmseqs2.py
)

set(OST_BINDINGS_PYMOD_SOURCES
  export_tmalign.cc
  wrap_bindings.cc
)

pymod(NAME bindings OUTPUT_DIR ost/bindings CPP ${OST_BINDINGS_PYMOD_SOURCES} 
      PY ${OST_BINDINGS})

=== modules/bindings/tests/CMakeLists.txt ===
set(OST_BINDINGS_UNIT_TESTS
  test_msms.py
  test_clustalw.py
  test_hhblits.py
  test_blast.py
  test_kclust.py
  test_naccess.py
  test_cadscore.py
  test_tmtools.py
  test_ialign.py
  test_lga.py
  test_hbplus.py
)

ost_unittest(MODULE bindings 
             SOURCES "${OST_BINDINGS_UNIT_TESTS}")

=== modules/conop/src/CMakeLists.txt ===
set(OST_CONOP_HEADERS
conop.hh
processor.hh
amino_acids.hh
diag.hh
model_check.hh
heuristic.hh
compound.hh
compound_lib.hh
module_config.hh
rule_based.hh
minimal_compound_lib.hh
compound_lib_base.hh
ring_finder.hh
)

set(OST_CONOP_SOURCES
processor.cc
amino_acids.cc
conop.cc
minimal_compound_lib.cc
compound_lib_base.cc
heuristic.cc
diag.cc
rule_based.cc
model_check.cc
compound.cc
compound_lib.cc
ring_finder.cc
)

module(NAME conop SOURCES ${OST_CONOP_SOURCES}
       HEADERS ${OST_CONOP_HEADERS} DEPENDS_ON ost_mol ost_geom ost_db)


if (WIN32)
  executable(NAME chemdict_tool SOURCES chemdict_tool.cc ../../io/src/zlib.cpp ../../io/src/gzip.cpp DEPENDS_ON ost_io STATIC)
else(WIN32)
  executable(NAME chemdict_tool SOURCES chemdict_tool.cc DEPENDS_ON ost_io STATIC)
endif(WIN32)

if (COMPOUND_LIB)
  if (EXISTS "${COMPOUND_LIB}")
    # this ensures that file is called 'compounds.chemlib' (as required)
    set(TO "${STAGE_DIR}/share/openstructure/compounds.chemlib")
    file(MAKE_DIRECTORY "${STAGE_DIR}/share/openstructure")
    add_custom_command(TARGET "ost_conop" PRE_BUILD
          DEPENDS "${COMPOUND_LIB}"
          COMMAND ${CMAKE_COMMAND} -E copy_if_different ${COMPOUND_LIB} ${TO})
    install(FILES ${TO} DESTINATION "share/openstructure")
  else()
    message(FATAL_ERROR "${COMPOUND_LIB} does not exist. \n"
            "Pass -DCOMPOUND_LIB=NONE if you would like to build "
            "OpenStructure without a compound library")
  endif()

endif()

=== modules/conop/tests/CMakeLists.txt ===
set(OST_CONOP_UNIT_TESTS
  test_amino_acids.cc
  test_heuristic_conop.cc
  tests.cc
  test_rule_based_conop.cc 
  helper.cc
  test_processor.py
)

if (COMPOUND_LIB)
  list(APPEND OST_CONOP_UNIT_TESTS test_compound.py
                                   test_cleanup.py)
endif()

ost_unittest(MODULE conop
             SOURCES "${OST_CONOP_UNIT_TESTS}")

=== modules/geom/src/CMakeLists.txt ===
set(OST_GEOM_HEADERS
def.hh
exc.hh
geom.hh
mat.hh
mat2.hh
mat3.hh
mat4.hh
vec.hh
vec2.hh
vec3.hh
vec4.hh
vecmat_op.hh
vecmat2_op.hh
vecmat3_op.hh
vecmat4_op.hh
circular_iterator.hh
constants.hh
composite.hh
composite2.hh
composite3.hh
composite_op.hh
composite2_op.hh
composite3_op.hh
aligned_cuboid.hh
vec_mat_predicates.hh
quat.hh
transform.hh
point_cloud.hh
module_config.hh
)

set(OST_GEOM_SOURCES
mat2.cc
mat3.cc
mat4.cc
vec3.cc
vecmat2_op.cc
vecmat3_op.cc
vecmat4_op.cc
composite2.cc
composite3.cc
composite2_op.cc
composite3_op.cc
quat.cc
transform.cc
aligned_cuboid.cc
point_cloud.cc
)

set(OST_GEOM_EXPORT_HELPERS
vector.hh
)

module(NAME geom
       HEADERS ${OST_GEOM_EXPORT_HELPERS} IN_DIR export_helper ${OST_GEOM_HEADERS}
       SOURCES ${OST_GEOM_SOURCES}
       LINK ${BOOST_LIBRARIES})
add_dependencies(ost_geom ost_config)

=== modules/io/pymod/CMakeLists.txt ===
set(OST_IO_PYMOD_SOURCES
  wrap_io.cc
  export_pdb_io.cc
  export_mmcif_io.cc
  export_omf_io.cc
  export_map_io.cc
)

set(OST_IO_PYMOD_MODULES
  __init__.py
  remote.py
  repository.py
)

if (NOT ENABLE_STATIC)
  pymod(NAME io CPP ${OST_IO_PYMOD_SOURCES} PY ${OST_IO_PYMOD_MODULES})
  if (STATIC_LIBRARIES)
    message("adding zlib libraries")
    target_link_libraries(_ost_io ${ZLIB_LIBRARIES})
  endif()
endif()

=== modules/io/src/CMakeLists.txt ===
add_subdirectory(mol)
add_subdirectory(seq)
add_subdirectory(img)

set(OST_IO_HEADERS
binary_data_sink.hh		
io_manager.hh
binary_data_source.hh		
module_config.hh
container_serialization.hh	
swap_util.hh
io_utils.hh
io_exception.hh
convert.hh
converting_streams.hh

formatted_line.hh
)

set(OST_IO_SOURCES
io_manager.cc
convert.cc
io_utils.cc
)
if (WIN32)
 set(OST_IO_SOURCES ${OST_IO_SOURCES} zlib.cpp gzip.cpp)
endif(WIN32)

foreach(fname ${OST_IO_MOL_SOURCES})
  set(OST_IO_SOURCES ${OST_IO_SOURCES} mol/${fname})
endforeach(fname ${OST_IO_MOL_SOURCES})

foreach(fname ${OST_IO_SEQ_SOURCES})
  set(OST_IO_SOURCES ${OST_IO_SOURCES} seq/${fname})
endforeach(fname ${OST_IO_SEQ_SOURCES})

foreach(fname ${OST_IO_IMG_SOURCES})
  set(OST_IO_SOURCES ${OST_IO_SOURCES} img/${fname})
endforeach(fname ${OST_IO_IMG_SOURCES})

####################################
# Add headers in subfolders (additionally) to OST_IO_HEADERS.
# In the end, we will have two copies (!) of each header in the subfolders.
# One copy in ost/io/<SUB> and one in ost/io.

# As it's silly to have duplicate headers, this behavior might be removed in the
# future. So please always include the headers in the subfolders.
# (e.g. use "#include <ost/io/mol/load_entity.hh>"
#       instead of #include <ost/io/load_entity.hh>)
# For compatibility reasons, we keep it for now (dates back to 2010).
foreach(fname ${OST_IO_MOL_HEADERS})
  set(OST_IO_HEADERS ${OST_IO_HEADERS} mol/${fname})
endforeach(fname ${OST_IO_MOL_HEADERS})

foreach(fname ${OST_IO_SEQ_HEADERS})
  set(OST_IO_HEADERS ${OST_IO_HEADERS} seq/${fname})
endforeach(fname ${OST_IO_SEQ_HEADERS})

foreach(fname ${OST_IO_IMG_HEADERS})
  set(OST_IO_HEADERS ${OST_IO_HEADERS} img/${fname})
endforeach(fname ${OST_IO_IMG_HEADERS})
####################################

set(OST_IO_DEPENDENCIES ost_base;ost_conop;ost_seq;ost_mol_alg;ost_img;ost_img_alg)
module(NAME io SOURCES "${OST_IO_SOURCES}" 
       HEADERS ${OST_IO_MOL_HEADERS} IN_DIR mol
               ${OST_IO_IMG_HEADERS} IN_DIR img
               ${OST_IO_SEQ_HEADERS} IN_DIR seq            
               ${OST_IO_HEADERS} 
       DEPENDS_ON ${OST_IO_DEPENDENCIES})
target_link_libraries(ost_io ${BOOST_IOSTREAM_LIBRARIES})
target_link_libraries(ost_io ${TIFF_LIBRARIES} ${PNG_LIBRARIES})

=== modules/io/tests/CMakeLists.txt ===
set(OST_IO_UNIT_TESTS
  test_io_pdb.py
  test_io_mmcif.py
  test_io_omf.py
  test_clustal.cc
  test_io_pdb.cc
  test_io_crd.cc
  test_io_dcd.cc
  test_io_sdf.cc
  test_io_sequence_profile.cc
  test_pir.cc
  test_iomanager.cc
  tests.cc
  test_star_parser.cc
  test_mmcif_reader.cc
  test_mmcif_info.cc
  test_io_img.cc
  test_exceptions.cc
)

ost_unittest(MODULE io
             SOURCES "${OST_IO_UNIT_TESTS}"
             LINK ost_mol ost_seq)

if(NOT ENABLE_STATIC)
  add_executable(test_mae_standalone test_mae_standalone.cc)
  target_link_libraries(test_mae_standalone ost_mol)
  target_link_libraries(test_mae_standalone ost_io)
  target_link_libraries(test_mae_standalone ${Boost_REGEX_LIBRARY})
endif()

=== modules/io/src/mol/CMakeLists.txt ===
set(OST_IO_MOL_SOURCES
entity_io_crd_handler.cc	
entity_io_pqr_handler.cc	
entity_io_mae_handler.cc	
pdb_reader.cc
entity_io_pdb_handler.cc	
pdb_writer.cc
entity_io_sdf_handler.cc	
entity_io_mmcif_handler.cc
sdf_reader.cc
sdf_writer.cc
save_entity.cc
load_entity.cc
surface_io_msms_handler.cc
load_surface.cc
chemdict_parser.cc
io_profile.cc
dcd_io.cc
star_parser.cc
mmcif_reader.cc
mmcif_info.cc
pdb_str.cc
stereochemical_params_reader.cc
omf.cc
PARENT_SCOPE
)

set(OST_IO_MOL_HEADERS
chemdict_parser.hh
star_parser.hh
mmcif_reader.hh
mmcif_info.hh
io_profile.hh
dcd_io.hh
entity_io_crd_handler.hh
entity_io_pqr_handler.hh
entity_io_mae_handler.hh
entity_io_mmcif_handler.hh
entity_io_handler.hh
pdb_reader.hh
entity_io_pdb_handler.hh
pdb_writer.hh
entity_io_sdf_handler.hh
sdf_reader.hh
sdf_writer.hh
save_entity.hh
load_entity.hh
surface_io_handler.hh
load_surface.hh
surface_io_msms_handler.hh
pdb_str.hh
stereochemical_params_reader.hh
omf.hh
PARENT_SCOPE
)

=== debian/changelog ===
openstructure (2.3.1-9) unstable; urgency=medium

  * libost-base2.3: Add Breaks: libost-base2.2 for smoother upgrades from
    bullseye. (Closes: #1036639)

 -- Andrius Merkys <merkys@debian.org>  Wed, 24 May 2023 00:56:53 -0400

openstructure (2.3.1-8) unstable; urgency=medium

  * Install shlibs into multiarch locations using debian/rules.
  * Build with OpenMM support only on architectures where it builds.
  * Turn on the optimization.

 -- Andrius Merkys <merkys@debian.org>  Tue, 16 Aug 2022 03:15:29 -0400

openstructure (2.3.1-6) unstable; urgency=medium

  * Backport two upstream commits fixing build and integration with OpenMM.
  * Add Provides and X-Python3-Version for Python module.
  * Add Recommends: libcifpp-data for openstructure package to keep the
    compounds library up-to-date.
  * Add debian/README.Debian describing handling of PDB compound library.

 -- Andrius Merkys <merkys@debian.org>  Tue, 03 May 2022 04:41:27 -0400

openstructure (2.3.1-5) unstable; urgency=medium

  * Adjust permissions of generated compounds library.
  * Enhance postinst output to make clear what it does.

 -- Andrius Merkys <merkys@debian.org>  Wed, 27 Apr 2022 10:56:34 -0400

openstructure (2.3.1-4) unstable; urgency=medium

  * Fix compound library generation.

 -- Andrius Merkys <merkys@debian.org>  Wed, 27 Apr 2022 02:08:06 -0400

openstructure (2.3.1-3) unstable; urgency=medium

  * Provide compound library even without libcifpp-data.

 -- Andrius Merkys <merkys@debian.org>  Tue, 26 Apr 2022 06:50:14 -0400

openstructure (2.3.1-2) unstable; urgency=medium

  * Fixing upgrade failures for openstructure package (Closes: #1004685).
  * Update standards version to 4.6.0, no changes needed.

 -- Andrius Merkys <merkys@debian.org>  Tue, 01 Feb 2022 01:26:38 -0500

openstructure (2.3.1-1) unstable; urgency=medium

  * New upstream version 2.3.1
  * Refreshing patches, dropping upstream-integrated ones.
  * Adding missing quotes to debian/libcifpp/openstructure.

 -- Andrius Merkys <merkys@debian.org>  Mon, 31 Jan 2022 01:26:20 -0500

openstructure (2.3.0~rc-1) unstable; urgency=medium

  * New upstream version 2.3.0~rc
  * Adding a trigger to be run by libcifpp to generate compounds.chemlib.
  * Removing upstream-integrated patches from debian/patches/series.
  * Fixing compatibility with OpenMM 7.7 via upstream patch.
  * Disabling increase-test-tolerance.patch for now.
  * Bumping copyright years.

 -- Andrius Merkys <merkys@debian.org>  Wed, 19 Jan 2022 06:42:42 -0500

openstructure (2.2.0-9) unstable; urgency=medium

  * Fixing incompatibility with matplotlib 3.5 (Closes: #999514)

 -- Andrius Merkys <merkys@debian.org>  Fri, 31 Dec 2021 06:57:26 -0500

openstructure (2.2.0-8) unstable; urgency=medium

  * Replacing hardcoded multiarch path with ${DEB_HOST_MULTIARCH} in
    debian/rules.

 -- Andrius Merkys <merkys@debian.org>  Mon, 06 Sep 2021 10:28:49 -0400

openstructure (2.2.0-7) unstable; urgency=medium

  * Building with openmm, packaging libost_mol_mm.so.

 -- Andrius Merkys <merkys@debian.org>  Sun, 29 Aug 2021 02:32:17 -0400

=== debian/control ===
Source: openstructure
Section: science
Priority: optional
Maintainer: Debichem Team <debichem-devel@lists.alioth.debian.org>
Uploaders:
 Andrius Merkys <merkys@debian.org>,
Build-Depends:
 clustalw <!nocheck>,
 cmake,
 debhelper-compat (= 13),
 dh-python,
 dssp <!nocheck>,
 libboost-all-dev,
 libeigen3-dev,
 libfftw3-dev,
 libglu1-mesa-dev,
 libopenmm-dev [amd64 arm64 ppc64el],
 libopenmm-plugins [amd64 arm64 ppc64el],
 libpng-dev,
 libqt5opengl5-dev,
 libsqlite3-dev,
 libtiff-dev,
 python3-dev,
 python3-matplotlib <!nocheck>,
 python3-numpy <!nocheck>,
 python3-pil <!nocheck>,
 python3-pyqt5,
 python3-scipy <!nocheck>,
 qtbase5-dev,
 sip-dev,
 voronota <!nocheck>,
Standards-Version: 4.6.0
Homepage: https://www.openstructure.org
Rules-Requires-Root: no
Vcs-Git: https://salsa.debian.org/debichem-team/openstructure.git
Vcs-Browser: https://salsa.debian.org/debichem-team/openstructure

Package: libost-base2.3
Architecture: any
Section: libs
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Breaks:
 libost-base2.2,
Description: Open-Source Computational Structural Biology Framework
 OpenStructure aims to provide an open-source, modular, flexible, molecular
 modelling and visualization environment. It is targeted at interested method
 developers in the field of structural bioinformatics.

Package: libost-bindings2.3
Architecture: any
Section: libs
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: Open-Source Computational Structural Biology Framework
 OpenStructure aims to provide an open-source, modular, flexible, molecular
 modelling and visualization environment. It is targeted at interested method
 developers in the field of structural bioinformatics.

Package: libost-conop2.3
Architecture: any
Section: libs
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: Open-Source Computational Structural Biology Framework
 OpenStructure aims to provide an open-source, modular, flexible, molecular
 modelling and visualization environment. It is targeted at interested method
 developers in the field of structural bioinformatics.

Package: libost-db2.3
Architecture: any
Section: libs
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: Open-Source Computational Structural Biology Framework
 OpenStructure aims to provide an open-source, modular, flexible, molecular
 modelling and visualization environment. It is targeted at interested method
 developers in the field of structural bioinformatics.

Package: libost-geom2.3
Architecture: any
Section: libs
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: Open-Source Computational Structural Biology Framework
 OpenStructure aims to provide an open-source, modular, flexible, molecular
 modelling and visualization environment. It is targeted at interested method
 developers in the field of structural bioinformatics.

Package: libost-gfx2.3
Architecture: any
Section: libs
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: Open-Source Computational Structural Biology Framework
 OpenStructure aims to provide an open-source, modular, flexible, molecular
 modelling and visualization environment. It is targeted at interested method
 developers in the field of structural bioinformatics.

Package: libost-gui2.3
Architecture: any
Section: libs
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: Open-Source Computational Structural Biology Framework
 OpenStructure aims to provide an open-source, modular, flexible, molecular
 modelling and visualization environment. It is targeted at interested method
 developers in the field of structural bioinformatics.

Package: libost-img-alg2.3
Architecture: any
Section: libs
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: Open-Source Computational Structural Biology Framework
 OpenStructure aims to provide an open-source, modular, flexible, molecular
 modelling and visualization environment. It is targeted at interested method
 developers in the field of structural bioinformatics.

Package: libost-img2.3
Architecture: any
Section: libs
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: Open-Source Computational Structural Biology Framework
 OpenStructure aims to provide an open-source, modular, flexible, molecular
 modelling and visualization environment. It is targeted at interested method
 developers in the field of structural bioinformatics.

Package: libost-info2.3
Architecture: any
Section: libs
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: Open-Source Computational Structural Biology Framework
 OpenStructure aims to provide an open-source, modular, flexible, molecular
 modelling and visualization environment. It is targeted at interested method
 developers in the field of structural bioinformatics.

Package: libost-io2.3
Architecture: any
Section: libs
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: Open-Source Computational Structural Biology Framework
 OpenStructure aims to provide an open-source, modular, flexible, molecular
 modelling and visualization environment. It is targeted at interested method
 developers in the field of structural bioinformatics.

Package: libost-mol-alg2.3
Architecture: any
Section: libs
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: Open-Source Computational Structural Biology Framework
 OpenStructure aims to provide an open-source, modular, flexible, molecular
 modelling and visualization environment. It is targeted at interested method
 developers in the field of structural bioinformatics.

Package: libost-mol-mm2.3
Architecture: amd64 arm64 ppc64el
Section: libs
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: Open-Source Computational Structural Biology Framework
 OpenStructure aims to provide an open-source, modular, flexible, molecular
 modelling and visualization environment. It is targeted at interested method
 developers in the field of structural bioinformatics.

Package: libost-mol2.3
Architecture: any
Section: libs
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: Open-Source Computational Structural Biology Framework
 OpenStructure aims to provide an open-source, modular, flexible, molecular
 modelling and visualization environment. It is targeted at interested method
 developers in the field of structural bioinformatics.

Package: libost-seq-alg2.3
Architecture: any
Section: libs
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: Open-Source Computational Structural Biology Framework
 OpenStructure aims to provide an open-source, modular, flexible, molecular
 modelling and visualization environment. It is targeted at interested method
 developers in the field of structural bioinformatics.

Package: libost-seq2.3
Architecture: any
Section: libs
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: Open-Source Computational Structural Biology Framework
 OpenStructure aims to provide an open-source, modular, flexible, molecular
 modelling and visualization environment. It is targeted at interested method
 developers in the field of structural bioinformatics.

Package: openstructure
Architecture: any
Depends:
 python3-ost,
 ${misc:Depends},
 ${python3:Depends},
 ${shlibs:Depends},
Recommends:
 libcifpp-data,
Description: Open-Source Computational Structural Biology Framework
 OpenStructure aims to provide an open-source, modular, flexible, molecular
 modelling and visualization environment. It is targeted at interested method
 developers in the field of structural bioinformatics.

Package: python3-ost
Architecture: any
Section: python
Depends:
 python3-matplotlib,
 python3-numpy,
 python3-pil,
 python3-pyqt5,
 ${misc:Depends},
 ${python3:Depends},
 ${shlibs:Depends},
Provides:
 ${python3:Provides},
X-Python3-Version: ${python3:Versions}
Description: Open-Source Computational Structural Biology Framework - Python 3 package
 OpenStructure aims to provide an open-source, modular, flexible, molecular
 modelling and visualization environment. It is targeted at interested method
 developers in the field of structural bioinformatics.

Package: libost-base-dev
Section: libdevel
Architecture: any
Depends:
 libost-base2.3 (= ${binary:Version}),
 ${misc:Depends},
Description: Open-Source Computational Structural Biology Framework
 OpenStructure aims to provide an open-source, modular, flexible, molecular
 modelling and visualization environment. It is targeted at interested method
 developers in the field of structural bioinformatics.

Package: libost-bindings-dev
Section: libdevel
Architecture: any
Depends:
 libost-bindings2.3 (= ${binary:Version}),
 ${misc:Depends},
Description: Open-Source Computational Structural Biology Framework
 OpenStructure aims to provide an open-source, modular, flexible, molecular
 modelling and visualization environment. It is targeted at interested method
 developers in the field of structural bioinformatics.

Package: libost-conop-dev
Section: libdevel
Architecture: any
Depends:
 libost-conop2.3 (= ${binary:Version}),
 ${misc:Depends},
Description: Open-Source Computational Structural Biology Framework
 OpenStructure aims to provide an open-source, modular, flexible, molecular
 modelling and visualization environment. It is targeted at interested method
 developers in the field of structural bioinformatics.

Package: libost-db-dev
Section: libdevel
Architecture: any
Depends:
 libost-db2.3 (= ${binary:Version}),
 ${misc:Depends},
Description: Open-Source Computational Structural Biology Framework
 OpenStructure aims to provide an open-source, modular, flexible, molecular
 modelling and visualization environment. It is targeted at interested method
 developers in the field of structural bioinformatics.

Package: libost-geom-dev
Section: libdevel
Architecture: any
Depends:
 libost-geom2.3 (= ${binary:Version}),
 ${misc:Depends},
Description: Open-Source Computational Structural Biology Framework
 OpenStructure aims to provide an open-source, modular, flexible, molecular
 modelling and visualization environment. It is targeted at interested method
 developers in the field of structural bioinformatics.

Package: libost-gfx-dev
Section: libdevel
Architecture: any
Depends:
 libost-gfx2.3 (= ${binary:Version}),
 ${misc:Depends},
Description: Open-Source Computational Structural Biology Framework
 OpenStructure aims to provide an open-source, modular, flexible, molecular
 modelling and visualization environment. It is targeted at interested method
 developers in the field of structural bioinformatics.

Package: libost-gui-dev
Section: libdevel
Architecture: any
Depends:
 libost-gui2.3 (= ${binary:Version}),
 ${misc:Depends},
Description: Open-Source Computational Structural Biology Framework
 OpenStructure aims to provide an open-source, modular, flexible, molecular
 modelling and visualization environment. It is targeted at interested method
 developers in the field of structural bioinformatics.

Package: libost-img-alg-dev
Section: libdevel
Architecture: any
Depends:
 libost-img-alg2.3 (= ${binary:Version}),
 ${misc:Depends},
Description: Open-Source Computational Structural Biology Framework
 OpenStructure aims to provide an open-source, modular, flexible, molecular
 modelling and visualization environment. It is targeted at interested method
 developers in the field of structural bioinformatics.

Package: libost-img-dev
Section: libdevel
Architecture: any
Depends:
 libost-img2.3 (= ${binary:Version}),
 ${misc:Depends},
Description: Open-Source Computational Structural Biology Framework
 OpenStructure aims to provide an open-source, modular, flexible, molecular
 modelling and visualization environment. It is targeted at interested method
 developers in the field of structural bioinformatics.

Package: libost-info-dev
Section: libdevel
Architecture: any
Depends:
 libost-info2.3 (= ${binary:Version}),
 ${misc:Depends},
Description: Open-Source Computational Structural Biology Framework
 OpenStructure aims to provide an open-source, modular, flexible, molecular

=== debian/rules ===
#!/usr/bin/make -f

OPEN_MM_PLUGIN_DIR=/usr/lib/$(DEB_HOST_MULTIARCH)/openmm/plugins
CONFIGURE_OPTIONS = -DOPTIMIZE=ON -DUBUNTU_LAYOUT=ON

ifeq ($(shell test -e $(OPEN_MM_PLUGIN_DIR) && echo YES),YES)
	CONFIGURE_OPTIONS += -DENABLE_MM=ON -DOPEN_MM_PLUGIN_DIR=$(OPEN_MM_PLUGIN_DIR)
endif

%:
	dh $@ --with python3

override_dh_auto_configure:
	dh_auto_configure -- $(CONFIGURE_OPTIONS)

override_dh_auto_install:
	dh_auto_install
	find debian/tmp/usr/lib -name '*.pyc' | xargs --no-run-if-empty rm

override_dh_install:
	dh_install
	find debian/python3-ost/usr/lib/python3/dist-packages -type f \
		| xargs --no-run-if-empty chmod -x
	find debian/tmp/usr/lib -name 'libost_*.so.*' \
		| while read LIB; \
			do dh_install -p$$(echo $$LIB | cut -d / -f 5 | cut -d . -f 1 | sed 's/_/-/g')2.3 \
				$$LIB usr/lib/$(DEB_HOST_MULTIARCH); \
			done
	find debian/tmp/usr/lib -name 'libost_*.so' \
		| while read LIB; \
			do dh_install -p$$(echo $$LIB | cut -d / -f 5 | cut -d . -f 1 | sed 's/_/-/g')-dev \
				$$LIB usr/lib/$(DEB_HOST_MULTIARCH); \
			done
